;*******************************************************************************
; Pulses
; Pulse symmetry tester 
;*******************************************************************************
         ORG 8192
         ICL 'equates.asm'
;===============================================================================
; Initialize
;===============================================================================
         lda #1
         sta COLDST        ;Allow cold start after RESET
         
         lda #52           ;Switch program recorder to turbo mode                                                             
         sta PACTL         ;Motor ON
         sta PBCTL         ;Command active
            
         lda #128          ;Disable interrupts and DMA
         sta POKMSK
         sta IRQEN
            
         lda #0
         sta NMIEN
         sta DMACLT
         
;===============================================================================
; Set PMG
;===============================================================================

         lda #$0C          ;Set PMG colors
         sta COLPM0
         lda #$1C
         sta COLPM1
         lda #$4C
         sta COLPM2
         
         lda #127          ;Set PMG initial locations
         sta HPOSP0
         sta HPOSP1
         sta HPOSP2
         
         lda #16
         sta GRAFP0
         lda #48
         sta GRAFP1
         sta GRAFP2
         
;===============================================================================
; Main loop
;===============================================================================
LOOP     lda SKSTAT         ;Get serial port
         and #16            ;Mask bit status
         sta COLBK          ;Background color
         cmp PREV           ;Is it as previous?
         beq SAME           ;Yes, go increase counter
         tax                ;Keep value in X
;-------------------------------------------------------------------------------
; Values differ, we reached edge
;-------------------------------------------------------------------------------         
DIFF     lda PREV           ;Check the original value
         beq WAS_LO         
         
WAS_HI   lda NUM_HI         ;Get count
         clc                ;Double the count
         asl        
         asl       
         clc
         adc #127           ;Display as player 1
         sta HPOSP1
         nop
         nop
         jmp SET_END           

WAS_LO   lda NUM_LO         ;Get count
         clc                ;Double the count
         asl    
         asl                
         sta NUM_LO
         lda #127
         sec
         sbc NUM_LO
         sta HPOSP2         ;Display as player 2      

SET_END  stx PREV           ;New previous SKSTAT value
         ldx #0             ;Clear counters
         stx NUM_LO
         stx NUM_HI
         
         jmp LOOP
;-------------------------------------------------------------------------------
; The value is just the same, increase the appropriate counter
;-------------------------------------------------------------------------------         
SAME     lda PREV            ;What is the value
         bne CNT_HI          ;Logical 1, increase HIGH
CNT_LO   inc NUM_LO          ;Logical 0, increase LOW
         jmp LOOP                  
         
CNT_HI   inc NUM_HI           
         jmp LOOP

;===============================================================================
;Data area
;===============================================================================
NUM_LO  .BYTE 0
NUM_HI  .BYTE 0
PREV    .BYTE 0

;===============================================================================
; RUN segment
;===============================================================================
         ORG RUNAD
         .WORD 8192     